NSENTER(1)

NAME
nsenter - run program with namespaces of other processes

SYNOPSIS
nsenter [options] [program] [arguments]

DESCRIPTION
Enters the namespaces of one or more other processes and then executes the specified program. Enterable namespaces are:

mount namespace
    mounting and unmounting filesystems will not affect rest of the system (CLONE_NEWNS flag), except for filesystems which are explicitly marked as shared (by mount --make-shared). See /proc/self/mountinfo for the shared flag.

UTS namespace
    setting hostname, domainname will not affect rest of the system (CLONE_NEWUTS flag).

IPC namespace
    process will have independent namespace for System V message queues, semaphore sets and shared memory segments (CLONE_NEWIPC flag).

network namespace
    process will have independent IPv4 and IPv6 stacks, IP routing tables, firewall rules, the /proc/net and /sys/class/net directory trees, sockets etc. (CLONE_NEWNET flag).

PID namespace
    children will have a set of PID to process mappings separate from the nsenter process (CLONE_NEWPID flag). nsenter will fork by default if changing the PID namespace, so that the new program and its children share the same PID namespace and are visible to each other. If --no-fork is used, the new program will be exec'ed without forking.

user namespace
    process will have distinct set of UIDs, GIDs and capabilities (CLONE_NEWUSER flag).

See the
    clone(2) for exact semantics of the flags.

If program is not given, run ``${SHELL}'' (default: /bin/sh).

OPTIONS
Argument with square brakets, such as [file], means optional argument. Command line syntax to specify optional argument --mount=/path/to/file. Please notice the equals sign.

-t, --target pid
    Specify a target process to get contexts from. The paths to the contexts specified by pid are:
    /proc/pid/ns/mnt
        the mount namespace
    /proc/pid/ns/uts
        the UTS namespace
    /proc/pid/ns/ipc
        the IPC namespace
    /proc/pid/ns/net
        the network namespace
    /proc/pid/ns/pid
        the PID namespace
    /proc/pid/ns/user
        the user namespace
    /proc/pid/root
        the root directory
    /proc/pid/cwd
        the working directory respectively

-m, --mount [file]
    Enter the mount namespace. If no file is specified enter the mount namespace of the target process. If file is specified enter the mount namespace specified by file.

-u, --uts [file]
    Enter the UTS namespace. If no file is specified enter the UTS namespace of the target process. If file is specified enter the UTS namespace specified by file.

-i, --ipc [file]
    Enter the IPC namespace. If no file is specified enter the IPC namespace of the target process. If file is specified enter the IPC namespace specified by file.

-n, --net [file]
    Enter the network namespace. If no file is specified enter the network namespace of the target process. If file is specified enter the network namespace specified by file.

-p, --pid [file]
    Enter the PID namespace. If no file is specified enter the PID namespace of the target process. If file is specified enter the PID namespace specified by file.

-U, --user [file]
    Enter the user namespace. If no file is specified enter the user namespace of the target process. If file is specified enter the user namespace specified by file.

-r, --root [directory]
    Set the root directory. If no directory is specified set the root directory to the root directory of the target process. If directory is specified set the root directory to the specified directory.

-w, --wd [directory]
    Set the working directory. If no directory is specified set the working directory to the working directory of the target process. If directory is specified set the working directory to the specified directory.

-F, --no-fork
    Do not fork before exec'ing the specified program. By default when entering a pid namespace enter calls fork before calling exec so that the children will be in the newly entered pid namespace.

-V, --version
    Display version information and exit.

-h, --help
    Print a help message.

SEE ALSO
setns(2), clone(2)

AUTHOR
Eric Biederman (ebiederm@xmission.com)

AVAILABILITY
The nsenter command is part of the util-linux package and is available from Linux Kernel Archive (ftp://ftp.kernel.org/pub/linux/utils/util-linux/).